/*------------------------------------------------------------------------------
#--  This file is a part of the libuc, microcontroler library
#--  Copyright (C) 2011, Alexis Jeandet
#--
#--  This program is free software; you can redistribute it and/or modify
#--  it under the terms of the GNU General Public License as published by
#--  the Free Software Foundation; either version 3 of the License, or
#--  (at your option) any later version.
#--
#--  This program is distributed in the hope that it will be useful,
#--  but WITHOUT ANY WARRANTY; without even the implied warranty of
#--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#--  GNU General Public License for more details.
#--
#--  You should have received a copy of the GNU General Public License
#--  along with this program; if not, write to the Free Software
#--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
#-------------------------------------------------------------------------------
#--                 Author : Alexis Jeandet
#--                   Mail : alexis.jeandet@gmail.com
#-------------------------------------------------------------------------------*/
#include "hexviewer.h"

void hexviewershow(const char* table,unsigned int size,unsigned int offset)
{
	int i=0,n=0;
	if(!offset)
		libucprintf("00");
	libucprintf(" ");
	for(i=0;i<(size);i+=16)
		{
			libucprintf("%X:\t",n+i+offset);
			for(n=0;n<16;n++)
			{
				if(table[n+i]==0)libucprintf("0");
				if(0x10>table[n+i])libucprintf("0");
				libucprintf("%X ",0xFF & table[n+i]);
				if((n & 3)==3)libucprintf(" ");
			}
			libucprintf("\t ");
			for(n=0;n<16;n++)
			{
				if(33<=table[n+i])
				{
					if(126>=table[n+i])
						libucprintf("%c",0x7f & table[n+i]);
					else
						libucprintf(".");
				}
				else
					libucprintf(".");
			}
			libucprintf("\n\r ");
			if((i & (3<<4))==(3<<4))libucprintf("\n\r ");
		}
}		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
